import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CalculatorPanel 
  extends JPanel 
{

  private static final int DISPLAY = 16;

  public CalculatorPanel () 
  {
    Calculator calculator = new Calculator ();

    JTextField display = new JTextField (DISPLAY);
    display.setEditable (false);
    display.setBackground (Color.WHITE);
    // The next line was added for class display purposes.
    // It's not in the slides.
    display.setFont(new Font("Arial", Font.BOLD, 18));

    JPanel buttons = calculatorButtons (calculator, display);

    setLayout (new BorderLayout ());
    add (display, BorderLayout.NORTH);
    add (buttons, BorderLayout.SOUTH);
  }

  private JPanel calculatorButtons (Calculator calculator, 
                                    JTextField display) 
  {
    JPanel buttons = new JPanel ();

    buttons.setLayout (new GridLayout (5, 4));

    buttons.add (new ClearButton (calculator, display));
    buttons.add (new ClearEntryButton (calculator, display));
    buttons.add (new EmptyButton (calculator, display));
    buttons.add (new EmptyButton (calculator, display));

    buttons.add (new DigitButton (7, calculator, display));
    buttons.add (new DigitButton (8, calculator, display));
    buttons.add (new DigitButton (9, calculator, display));
    buttons.add (new OperatorButton (Calculator.DIVIDE, calculator, display));

    buttons.add (new DigitButton (4, calculator, display));
    buttons.add (new DigitButton (5, calculator, display));
    buttons.add (new DigitButton (6, calculator, display));
    buttons.add (new OperatorButton (Calculator.MULTIPLY, calculator, display));

    buttons.add (new DigitButton (1, calculator, display));
    buttons.add (new DigitButton (2, calculator, display));
    buttons.add (new DigitButton (3, calculator, display));
    buttons.add (new OperatorButton (Calculator.SUBTRACT, calculator, display));

    buttons.add (new DigitButton (0, calculator, display));
    buttons.add (new DecimalButton (calculator, display));
    buttons.add (new EqualsButton (calculator, display));
    buttons.add (new OperatorButton (Calculator.ADD, calculator, display));

    return buttons;
  }
}
